import os, sys
from control.NN_caller_ import perform_testing
from mydetails import info
import inspect
from pathlib import Path
"""
User Specified:
"""

global program_path
global project


if __name__ =='__main__':
    print('\n')
    _, _, project, _, _ = info()

    # ---------------------------------------------------------
    # ----------------------   USER INPUTS   ------------------

    subset =    0                # Training Rank (str)
    n =         [1]              # Number of repetitions
    filelist =  ['example.npy']  # Classification files
    name_id =   'example_id'     # Output file ID
    qlist =     [1.3]            # d0 Values to test
    nrange =    [2001]           # Max. training iterations
    maxerrs =   [0.0001]         # Max. training error to stop
    repeat =    2                # No. of trrained networks

    hidlay1 =   [20]             # No. of nodes in the first
                                 # hidden layer
    hidlay2 =   [60]             # No. of nodes in the second
                                 # hidden layer

    convergence = False         # Save errors every iteration?
                                # if yes: provide Path and filename

    mode = 'all'                # Allowed Modes for the feature
                                # extraction. Allowed are:
                                # 'WBFE', 'FDFE' and 'all'
    # ---------------------------------------------------------
    # ---------------------------------------------------------
    # convergence = '/Users/patrickpaitz/Phd/code_testing/ANN/RESULTS/example/convergence_test.csv'

    if mode not in ['WBFE', 'FDFE', 'all']:
        print('No valid mode entered, using default setting: mode = "WWBFE"')
        mode = 'extr'

    if mode == 'WBFE':
        mode = 'extr'

    if mode == 'FDFE':
        mode = 'ft'
    subset = str(subset)
    x = [str(i) for i in n]
    path = os.path.dirname(os.path.abspath(inspect.stack()[0][1]))
    basepath = Path(path).parents[1]
    program_path= str(basepath)
    projectlists = [[project, project]]
    subsets = False  # Not implemented in this version
    """
    RUN A FULL TRAINING AND TESTING RUN
    """
    if convergence != False:
        x = input(str('Are you sure you want to save the errors for every iteration in: \n '+ convergence+ '\t[y/n] \n>> '))
        if x == 'y':
            pass
        else:
            convergence = False
    perform_testing(
                    subset,
                    n,
                    filelist,
                    qlist,
                    projectlists,
                    subsets,
                    nrange,
                    maxerrs,
                    options = None,
                    numpyname = program_path+"/FILES/networks/"+subset,
                    hidlay1 = [20],
                    hidlay2 = [60],
                    hidlay3 = None,
                    repeat = repeat,
                    name_add = name_id,
                    convergence = convergence,
                    mode = mode
                    )
