import numpy as np 

def sigmoid(x, Derivative=False): 
  if Derivative == True:
    tmp = sigmoid(x, Derivative=False)
    return (tmp*(1-tmp))
  else: 
    return (1. / (1.+np.exp(-x)))

def linear(x, Derivative=False): 
  if Derivative == True:
    return 1.0
  else: 
    return x

def tanh(x, Derivative=False): 
  if Derivative == True:
    # tmp = sigmoid(x, Derivative=False)
    return (1.- np.tanh(x)**2)
  else: 
    return (np.tanh(x))

def tanh_p(x): 
  return tanh(x, Derivative=True)

def sigmoid_p(x): 
  return sigmoid(x, Derivative=True)

def linear_p(x): 
  return linear(x, Derivative=True)
