import numpy as np
import pandas as pd
import glob, sys, os
sys.path.append(os.path.abspath('..'))
from pathmaker import basepath_f
print '\n\n'
_dir = basepath_f()
_dir = _dir + '/RESULTS/nn/final/*.csv'
_dir = glob.glob(_dir)
print _dir
import matplotlib.pyplot as plt
from matplotlib import colors
import matplotlib.cm as cmx



def plotter4(df, x='iter', y='err(%)', xticks=None, xticklabel = ['1', '2', '3'], method = 'extr'):
    a11 = df.loc[df['train']=='/a11/']
    a12 = a11.loc[a11['test']=='/a20/']
    a11 = a11.loc[a11['test']=='/a11/']
    a20 = df.loc[df['train']=='/a20/']
    a21 = a20.loc[a20['test']=='/a11/']
    a20 = a20.loc[a20['test']=='/a20/']
    yl = [y+' a11-a11', y+' a20-a20', y+' a20-a11', y+'a11-a20']

    fig, ax = plt.subplots(4, 2, sharex = True, sharey = True)


    for i in range(4):
        if i == 0: 
            df = a11
        elif i ==1: 
            df = a20
        elif i ==2: 
            df = a21
        elif i==3: 
            df = a12

        # df = l[i]
        dff = df.loc[df['type']=='four']
        dfe = df.loc[df['type']=='extr']

        df = dfe
        p = df.loc[df['fname']=='Patrick']
        l = df.loc[df['fname']=='Laura']
        k = df.loc[df['fname']=='Korbi']

        # fig, ax = plt.subplots(1,2, sharex = True, sharey = True)
        # plt.figure()

        ax[i,0].scatter(p[x], p[y], label = 'Patrick', color='b')
        if i==0:
            ax[i,0].scatter(l[x], l[y], label = 'Laura', color='g')
            ax[i,0].scatter(k[x], k[y], label = 'Korbi', color='r')
            ax[i,0].set_title('Feature Extraction')
            ax[i,0].legend()
        if i ==3: 
            ax[i,0].set_xlabel(x)
        
        ax[i,0].set_ylabel(y)
        ax[i,0].grid()
        ax[i,0].set_ylabel(yl[i])

        df = dff
        p = df.loc[df['fname']=='Patrick']
        l = df.loc[df['fname']=='Laura']
        k = df.loc[df['fname']=='Korbi']

        ax[i,1].scatter(p[x], p[y], label = 'Patrick', color='b')
        if i==0:
            ax[i,1].scatter(l[x], l[y], label = 'Laura', color='g')
            ax[i,1].scatter(k[x], k[y], label = 'Korbi', color='r')
            ax[i,1].set_title('Fourier Spectrum')
            ax[i,1].legend()
        if i ==3: 
            ax[i,1].set_xlabel(x)
            # plt.xlabel(x)
        ax[i,1].set_ylabel(yl[i])
        ax[i,1].yaxis.set_label_position("right")
        ax[i,1].grid()
        
        if xticks != None: 
            plt.xticks(xticks, xticklabel)
        # plt.ylabel(y)

    fig.subplots_adjust(hspace=0)
    fig.suptitle(x +' vs ' + y, fontsize=14)
        


def plotter2(df, x='iter', y='err(%)', xticks=None, xticklabel = ['1', '2', '3'], method = 'extr'): 
    
    dff = df.loc[df['type']=='four']
    dfe = df.loc[df['type']=='extr']
    dfe2 = df.loc[df['type']=='Cextr']
    dff2 = df.loc[df['type']=='Cft']

    df = dfe
    p = df.loc[df['fname']=='Patrick']
    l = df.loc[df['fname']=='Laura']
    k = df.loc[df['fname']=='Korbi']
    d = df.loc[df['fname']=='DP']
    df = dfe2
    p2 = df.loc[df['fname']=='Patrick']
    # l2 = df.loc[df['fname']=='Laura']
    # k2 = df.loc[df['fname']=='Korbi']
    # d2 = df.loc[df['fname']=='DP']

    fig, ax = plt.subplots(1,2, sharex = True, sharey = True)
    # plt.figure()    

    ax[0].scatter(p[x], p[y], label = 'Patrick', color='b')
    ax[0].scatter(p2[x], p2[y], label = 'Patrick', color='magenta')
    ax[0].scatter(l[x], l[y], label = 'Laura', color='g')
    ax[0].scatter(k[x], k[y], label = 'Korbi', color='r')
    ax[0].scatter(d[x], d[y], label = 'DP', color='cyan')
    ax[0].set_title('Feature Extraction')
    ax[0].legend()
    ax[0].set_xlabel(x)
    ax[0].set_ylabel(y)
    ax[0].grid()

    df = dff
    p = df.loc[df['fname']=='Patrick']
    l = df.loc[df['fname']=='Laura']
    k = df.loc[df['fname']=='Korbi']
    d = df.loc[df['fname']=='DP']
    df = dff2
    p2 = df.loc[df['fname']=='Patrick']

    ax[1].scatter(p[x], p[y], label = 'Patrick', color='b')
    ax[1].scatter(p2[x], p2[y], label = 'Patrick', color='magenta')
    ax[1].scatter(l[x], l[y], label = 'Laura', color='g')
    ax[1].scatter(k[x], k[y], label = 'Korbi', color='r')
    ax[1].scatter(d[x], d[y], label = 'DP', color='cyan')

    ax[1].set_title('Fourier Spectrum')
    ax[1].legend()
    ax[1].set_xlabel(x)
    ax[1].yaxis.set_label_position("right")
    ax[1].grid()

    fig.subplots_adjust(hspace=0)

    fig.suptitle(x +' vs ' + y, fontsize=14)
    plt.xlabel(x)
    if xticks != None: 
        plt.xticks(xticks, xticklabel)
    plt.ylabel(y)


def plotter3(df, x='iter', y='err(%)',z ='qcrit', xticks=None, xticklabel = ['1', '2', '3'], method = 'extr'): 
    markers = np.array(['o', 's', '^', 'd', '8', 'D', '<'])
    colors2 = np.array(['black', 'dimgrey', 'gray', 'slategray'])
    pe = df
    # pe = df.loc[df['fname']=='Patrick']
    pf = pe.loc[pe['type']=='four']
    tmp = pe.loc[pe['type']=='Tft10']
    pf = pd.concat([pf, tmp])
    
    tmp = pe.loc[pe['type']=='Textr10']
    pe = pe.loc[pe['type']=='extr']
    
    pe = pd.concat([pe, tmp])

    fig, ax = plt.subplots(1,2, sharex = True, sharey = False, figsize=(18,8), dpi = 600)
    jet = cm = plt.get_cmap('Greys_r') 

    # colors_ = cm.get_cmap('gist_earth',5)
    # plt.figure()   
    classes = np.unique(pe[z])
    values = range(len(classes))
    cNorm  = colors.Normalize(vmin=0, vmax=len(classes))
    scalarMap = cmx.ScalarMappable(norm=cNorm, cmap=jet)
    ttmp = 0
    for i in classes:
        tmp = pe.loc[pe[z]==i]
        colorVal = scalarMap.to_rgba(values[ttmp])
        colorVal = colors2[ttmp]
        # ax[0].scatter(tmp[x], tmp[y], label = str(i), color = colorVal, s=60, marker = markers[ttmp])
        ax[0].plot(tmp[x], tmp[y], label = str(i), color = colorVal, markersize=10, marker = markers[ttmp])
        ttmp=ttmp+1
    if x == 'qcr': 
        x1 = 'Classification quality threshold '+ '$\mathbf{\\gamma}$'
    elif x =='err(%)g':
        x1 = 'Classification error $\\xi_{good}$ [%]'
    elif x =='err(%)b':
        x1 = 'Classification error $\\xi_{bad}$ [%]'
    elif x =='err(%)t':
        x1 = 'Classification error $\\xi_{total}$ [%]'
    else: 
        x1 = x

    if y == 'qcr': 
        y1 = 'Classification quality threshold '+ '$\mathbf{\\gamma}$'
    elif y =='err(%)g':
        y1 = 'Classification error $\\xi_{good}$ [%]'
    elif y =='err(%)b':
        y1 = 'Classification error $\\xi_{bad}$ [%]'
    elif y =='err(%)t':
        y1 = 'Classification error $\\xi_{total}$ [%]'
    else: 
        x1 = x
    ax[0].set_title('WBFE')
    ax[0].legend(loc=0)
    ax[0].set_xlabel(x1, fontsize=18)
    
    ax[0].set_ylabel(y1, fontsize=18)
    ax[0].grid()

    classes = np.unique(pf[z])
    values = range(len(classes))
    cNorm  = colors.Normalize(vmin=0, vmax=len(classes))
    scalarMap = cmx.ScalarMappable(norm=cNorm, cmap=jet)
    ttmp = 0
    for i in classes:
        tmp = pf.loc[pf[z]==i]
        colorVal = scalarMap.to_rgba(values[ttmp])
        colorVal = colors2[ttmp]
        # ax[1].scatter(tmp[x], tmp[y], label = str(i), color = colorVal, s=60, marker = markers[ttmp])
        ax[1].plot(tmp[x], tmp[y], label = str(i), color = colorVal, markersize=10, marker = markers[ttmp])
        ttmp=ttmp+1


    ax[1].set_title('FT')
    ax[1].legend(loc=0)
    # if x == 'qcr': 
        # ax[1].set_xlabel('$\gamma$')
    # else: 
    ax[1].set_xlabel(x1, fontsize=18)
    ax[1].set_ylabel(y1, fontsize=18)
    ax[1].yaxis.set_label_position("right")
    ax[1].grid()

    fig.subplots_adjust(hspace=0)
    maxerrr = np.unique(df['maxerr'])[0]
    fig.suptitle('$M_{max}$ = '+str(maxerrr)+';  Topology: [20:60]', fontsize=14)
    # plt.xlabel(x1)
    if xticks != None: 
        plt.xticks(xticks, xticklabel)
    # plt.ylabel(y1)
    return fig, ax




def get_dataframe(dfo, type1=None,key0=None, key0val=None, key1=None, key1val =None, key2=None ,key2val =None, key3=None, key3val =None, train=None, test=None, findmin=False, minfactor = 1.1, iter=None):
    # Type1: Tft, four, extr, Textr, Tft5, Textr5
    df = dfo.copy()
    if type1 != None:
        df = df.loc[df['type']==type1]
    if train != None:
        df = df.loc[df['train']==train]
    if test != None: 
        df = df.loc[df['test']==test]
    if train == '/a11b/': 
        df = df.loc[df['sample']<700]
    if iter != None: 
        df = df.loc[df['iter']==iter]
    if key0 != None: 
        df = df.loc[df[key0]==key0val]
    if key3 != None: 
        df = df.loc[df[key3]==key3val]
    if key2 != None: 
        df = df.loc[df[key2]==key2val]
    if key1 != None: 
        df = df.loc[df[key1]==key1val]
    if findmin == True: 
        df = df.loc[df['err(%)t']<=np.min(df['err(%)t'])*minfactor]
    return df

def find_mins(df, findmin=True):
    dflister = []
    pd.set_option('expand_frame_repr', False)
    # print df2
    sets = ['/glob/', '/a11b/']
   
    for train in sets:
        for nnn in np.unique(df['fileid']): 
            for test in sets:
                for nn in np.unique(df['maxerr']):
                    for q in range(0, len(np.unique(df['qcr']))):
                        for iii in ['Tft', 'Textr', 'Tft10', 'Textr10']:
                            df2 = get_dataframe(df, findmin=findmin, train=train, test=test, 
                                                iter =None, 
                                                key0='fileid', key0val=nnn,
                                                key3='maxerr', key3val=nn, 
                                                key2='qcr', key2val=np.unique(df['qcr'])[q], 
                                                key1='type', key1val=iii)
                            # print train, test, nn 
                            dflister.append(df2)
                        # print df2, '\n\n'
    # print dflister[3]
    # pd.reset_option('expand_frame_repr')
    return dflister






if __name__=='__main__': 
    file1 = _dir[0]


    df = pd.read_csv(file1, sep='\t')
    df['fileid'] = 0


    for ii in range(1, len(_dir)): 
        file1 = _dir[ii]
        tmp = pd.read_csv(file1, sep='\t')
        tmp['fileid'] = ii
        df = pd.concat([df, tmp])

    df.dropna(axis=0, how='any', thresh=None, subset=None, inplace=True)
    # df = df.loc[df['qcr']==1.2]
    tmp = df.copy()
    df = df.loc[df['type'] == 'Tft10']
    df2 = tmp.loc[tmp['type']== 'Textr10']

    df = pd.concat([df, df2])
    # df = df.loc[df['nnconfig']==8]
    # df = df.loc[df['sample']<400]
    # df = df.loc[df['sample']>400]
    # df = df.loc[df['train']!=df['test']]

    # df = df.loc[df['type']=='Tft']


    # df.to_csv('/home/patrick/1Thesis/nFINAL/RESULTS/nn/n/Final.csv', sep='\t') 


    df['nnconfig2'] = df['nnconfig']
    df.reset_index(inplace=True, drop=True)
    nnc_labels = df['nnconfig'].as_matrix()
    nnc_index = np.unique(df['nnconfig'])
    for i in range(len(nnc_index)):
        df['nnconfig'].replace(nnc_index[i], i, inplace=True)
    print df
    # df = df.loc[df['nnconfig']==4]
    dflist = find_mins(df, findmin=True)
    dfnew = pd.concat(dflist)
    pd.set_option('display.max_rows', None)
    # print dfnew

    # dfa = dfnew.loc[dfnew['train']==dfnew['test']]
    dfa = dfnew
    # dfa = dfa.loc[dfa['nnconfig']==4]

    # dflist2 = find_mins(df, findmin=False)
    # dfnew2 = pd.concat(dflist2)
    print dfa

    '''
    OPTIONS:
    nnconfig    
    fname   
    qcr 
    maxerr  
    type    
    train   
    test    
    iter_t  
    iter    
    sample  
    ngood   
    nbad    
    err(%)g 
    err(%)b 
    err(%)t
    '''

    dfa.to_csv('/home/patrick/1Thesis/nFINAL/RESULTS/extracted/plots.csv', sep='\t') 

    # finally

    # plotter3(dfnew2, x='iter', y='err(%)t', z='maxerr')

    # plotter3(dfa, x='iter', y='err(%)t', z='fileid')
    # plotter3(dfa, x='qcr', y='err(%)t', z='nnconfig2')


    # plotter3(dfa, x='sample', y='err(%)t', z='iter')

    # plotter3(dfa, x='err(%)g', y='err(%)b', z='maxerr')

    # plt.show()
    # 




    # plotter3(dfa, x='iter', y='err(%)t', z='test')



    # plotter3(dfa, x='nnconfig', y='err(%)t', z='nnconfig2')



    dfc = dfa.copy()
    dfc = dfc.loc[dfc['maxerr']==0.1]
    plotter3(dfc, x='err(%)g', y='err(%)b', z='sample')
    plt.show()
