from mpl_toolkits.basemap import Basemap
import numpy as np 
import glob
import os, sys, glob
from obspy import read_inventory
import matplotlib.pyplot as plt
sys.path.append(os.path.abspath('..'))

from pathmaker import basepath_f
# import pandas as pd 

# 
# project = 'a10'
# xmlpath = '/media/patrick/Data1/exch/Downloads/'+project+'/dllist/stationxml'
# corrletationpath = '/home/patrick/1Thesis/2Correlations_out/a11'

def create_stations(save = False):
    print 'creating the file....'
    project1 = 'a10'
    project2 = 'a11b'
    xmlpath = '/media/patrick/Data1/exch/Downloads/'+project1+'/dllist/stationxml/'
    # corrletationpath = '/home/patrick/1Thesis/2Correlations_out/'+project2+'/*'
    # corrletationpath = '/media/patrick/Data1/exch/DAINT/download/correlations/'+project2+'/tomo/*'
    correlationpath = basepath_f()
    correlationpath = '/home/patrick/1Thesis/nFINAL/RESULTS/DP/traces_for_inversion/*.mseed'
    gxml = os.path.basename(glob.glob(xmlpath+'*.xml')[0]).split('.xml')[0]

    fig1 = plt.figure(1)
    image = Basemap(projection="ortho", lon_0=20, lat_0=5, resolution="c")
    'ortho, eck4, moll'
    image.drawcoastlines()
    # image.fillcontinents(color="moccasin", lake_color="deepskyblue")
    image.fillcontinents(color="gray", alpha=0.4)
    image.drawcountries()
    image.drawmeridians(np.arange(0,360,30))
    image.drawparallels(np.arange(-90,90,30))


    corrlist = glob.glob(correlationpath)
    for ii in range(len(corrlist)):
        if ii%10 == 0:
            print ('%.2f ') % (float(ii)/len(corrlist)*100) + '%'
        gcor = os.path.basename(corrlist[ii]).split('.'+'1'+'.SAC')[0]
        s_net, s_sta, r_net, r_sta = extract_infos(gcor)
        xml = find_xml(xmlpath, s_net, s_sta)[0]
        lat1, lon1 = find_coord(xml)
        x1, y1 = image(lon1, lat1)
        image.plot(x1, y1, color='red',marker='^', markersize=7.)
        xml = find_xml(xmlpath, r_net, r_sta)[0]
        lat2, lon2 = find_coord(xml)
        x2, y2 = image(lon2, lat2)
        image.plot(x2, y2, color='red',marker='^', markersize=7.)
    
        image.drawgreatcircle(lon1, lat1, lon2, lat2, color ='red', linewidth='0.7', alpha=0.9)
    # plt.show()
    # plt.title('Stations for crosscorrelations with raypaths')
    fig1.savefig('/home/patrick/1Thesis/nFINAL/RESULTS/maps/'+project2+'newrayglob23.png')
    # fig1.close()
    plt.close(fig1)

    # fig1 = plt.figure(2)
    # image = Basemap(projection="eck4", lon_0=20, lat_0=5, resolution="c")
    # 'ortho, eck4, moll'
    # image.drawcoastlines()
    # # image.fillcontinents(color="moccasin", lake_color="deepskyblue")
    # image.fillcontinents(color="gray", alpha=0.4)
    # image.drawcountries()
    # image.drawmeridians(np.arange(0,360,30))
    # image.drawparallels(np.arange(-90,90,30))
    # for ii in range(len(corrlist)):
    #     if ii%10 == 0:
    #         print ('%.2f ') % (float(ii)/len(corrlist)*100) + '%'
    #     gcor = os.path.basename(corrlist[ii]).split('.'+'1'+'.SAC')[0]
    #     s_net, s_sta, r_net, r_sta = extract_infos(gcor)
    #     xml = find_xml(xmlpath, s_net, s_sta)[0]
    #     lat1, lon1 = find_coord(xml)
    #     x1, y1 = image(lon1, lat1)
    #     image.plot(x1, y1, color='red',marker='^', markersize=7.)
    #     xml = find_xml(xmlpath, r_net, r_sta)[0]
    #     lat2, lon2 = find_coord(xml)
    #     x2, y2 = image(lon2, lat2)
    #     image.plot(x2, y2, color='red',marker='^', markersize=7.)
    
    #     # image.drawgreatcircle(lon1, lat1, lon2, lat2, color ='red', linewidth='0.15', alpha=0.8)
    # # plt.show()
    # # plt.title('Stations for crosscorrelations with raypaths')
    # fig1.savefig('/home/patrick/1Thesis/nFINAL/RESULTS/maps/'+project2+'newglob.png')

def extract_infos(gcor):
    source = gcor.split('-')[0]
    receiver = gcor.split('-')[-1] 
    s_net = source.split('.')[0]
    s_rec = source.split('.')[1]
    r_net = receiver.split('.')[0]
    r_rec = receiver.split('.')[1]
    return s_net, s_rec, r_net, r_rec

def find_xml(xmlpath, net, sta):
    xml =  glob.glob(xmlpath+net+'.'+sta+'.xml')
    return xml

def find_coord(path_to_xml):
    sta = path_to_xml.split('/')[-1].split('.')[1]
        # try:
    inv = read_inventory(path_to_xml)
    sta = inv[0][0]
    staname = sta.code
    lat=sta.latitude
    lon=sta.longitude
    return float(lat), float(lon)

if __name__ == '__main__': 
    create_stations()
    # print os.path.dirname(os.path.realpath(__file__))


# lat = df.loc[:, "Latitude"].as_matrix()
# lon = df.loc[:, "Longitude"].as_matrix()
