import numpy as np
import glob
import obspy
import sys
import os
import matplotlib.pyplot as plt
x = os.path.abspath('..')
sys.path.append(x)
import gc
from scipy import interpolate
from matplotlib.ticker import MultipleLocator, FormatStrFormatter

from pathmaker import pathmaker
from features import featureextracter_load, featureextracter
periods = ['50-100',"10_50s", "100_200s", "1_25s", "25_50s", "20_40s", "5_15s"]

fpath = '/home/patrick/1Thesis/nFINAL/RESULTS/images_/s5small'
# pmin defaults: 50 -100
# Periods 1: 10-50
# Periods 2: 100-200
# Periods 3: 1 - 25 
# Periods 4: 25-50
# Periods 5: 20-40
# Periods 6: 5 - 15
def resample(f, step = 10): 
    f.stream3 = f.stream_.copy()[0::step]
    f.stream_ = f.stream_[0::step]
    f.ftfeatures = f.ftfeatures[0::step]
    f.reconstructions = f.reconstructions[0::step]
def fun(n,project,type2,period1):
    out1 = 0
    try: 
        type = '*.SAC'
        # project = '/a11b/'

        # print 'nothing chosen, please do so.'
        f = featureextracter_load(type=type2, project=project, number_of_features=n, period1 = str(period1), pertrue=period1)
        i = 0

        # f.stream_ = f.stream_[1:3]
        # f.reconstructions = f.reconstructions[1:3]
        # f.plot_reconstructions()
        if project == 'glob': 
            resample(f, step=20)
        else: 
            resample(f, step=5)
        f.recons3 = f.reconstructions
    # f1, ax1 = f.plot_stream()
        i = 0
        for trace in f.stream3: 
            trace.data = f.recons3[i]
            i+=1
        # for trace in f.stream_:
        #     trace.data = f.reconstructions[i]
        #     i+=1
        # if project in ['/a11b/', '/a11/']: 
        #     f.stream2 = f.stream_[0::3]
        # if project in ['/glob/']: 
        #     f.stream2 = f.stream_[0::25]


        f3, ax3 = f.plot_stream2(subf = True, streamarr = [f.stream_, f.stream3], 
             headers=['Correlations', 'FE, N='], features=['', n], frequencies=[periods[period1], periods[period1]])
    # fig2, ax = f.plot_stream2(subf = True, streamarr = [f.stream_], 
             # headers=['Correlations', 'FE, N='], features=['', 4], frequencies=['50-100s', '50-100s'])
        f3.savefig('/home/patrick/1Thesis/0FINAL/RESULTS/sections2/__'+periods[period1]+'_proj_'+project.split('/')[1]+'_type_'+type2+str(out1)+'_nfeat_'+str(n)+'_'+'.png', title=project.split('/')[1]+type2+str(out1)+'__'+'features_'+str(n))
        plt.close(f3)
        out1 +=1
        del f.stream_,f.recons3,f.corrlist, f, f3, ax3
    except Exception as e: 
        print e
    return None
    # gc.collect()



out1 = 0
one = False
if one == True: 

    for n in range(1,5,1): 
        # for project in ['/a11b/', '/a11/', '/glob/']: 
        for project in ['/a11b/', '/a11/', 'glob'] : 
            for type2 in ['good', 'bad', 'all']:
                for period1 in xrange(1,7,1):
                    x = fun(n,project,type2,period1)


def bigplotter(f, nrows=2, ncols=2, feats = True, proc = False, feats2 = False):
    aa = 15 
    bb = 10
    # ylims = [[-0.05, 0.05], [-0.02, 0.02], [-0.5, 0.5], [-0.25, 0.25]]
    f.stream_.normalize()
    f.stream_.sort()
    # stream = f.stream_[4:]
    stream = f.stream_
    if feats == True:
        feat = f.reconstructions[4:]
    if feats in [True, 'corrs']:
        fig, axarr = plt.subplots(nrows, ncols, sharex=True, sharey=True, figsize=(aa,bb), dpi = 600)
    elif feats == False: 
        fig, axarr = plt.subplots(nrows, ncols, sharex=True, sharey=False, figsize=(aa,bb))

    fig.subplots_adjust(hspace=0.05)
    fig.subplots_adjust(wspace=0.05)
    for r in range(nrows): 
        for c in range(ncols):
            i = r*ncols+c
            # stream[i].data = stream[i].data / np.max ()
            try:
                distance = stream[i].stats.sac.dist
            except: 
                print 'no distance attribute'
            name = f.corrlist[i].split('.1.')[0]
            if feats ==False: 
                try: 
                    name = 'NET='+f.stream_[i].stats.network+'  STA='+f.stream_[i].stats.station+'  LOC='+f.stream_[i].stats.location+' $t_s$ = 01 Mar 2012'
                    # ttmp = name.split('__')[1].split('T')[0]+'T'
                    
                    # ts = np.datetime64(ttmp[0:4]+'-'+ttmp[4:6]+'-'+ttmp[6:8])
                    # print ts
                    # name = name.split('_')[0]+' t_s ='+str(ts)
                # if proc == True: 
                    # pass
                    # ttmp = name.split
                except IndexError as e:
                    print e
                    name = name.split('.MSEED')[0]
            if feats =='corrs': 
                name = f.corrlist[i].split('.ccc')[0]

            if feats == True:
                axarr[r,c].plot(stream[(i)].data, color='black', linewidth='0.7', label='$\eta(t)$ for '+name)
                axarr[r,c].yaxis.set_major_formatter(plt.NullFormatter())
            elif feats == False: 
                axarr[r,c].plot(np.arange(len(stream[(i)]))/3600./24.,stream[(i)].data, color='black', linewidth='0.5', label=name)
                # axarr[r,c].set_ylim(ylims[r*c-1])
                # mean = np.mean(stream[i].data)
                # upl = mean + 0.1
                # lol = mean - 0.1
                # axarr[r,c].set_ylim([-0.3, 0.3])
                # if r!=(nrows-1):
                    # if c != 0:
                axarr[r,c].yaxis.set_major_formatter(plt.NullFormatter())
            elif feats =='corrs': 
                axarr[r,c].plot(f.time, stream[(i)].data, color='black', linewidth=0.5, label=name)
                axarr[r,c].yaxis.set_major_formatter(plt.NullFormatter())
                # if c!=0:
                # axarr[r,c].yaxis.set_major_formatter(plt.NullFormatter())
                    # axarr[r,c].xaxis.set_major_formatter(plt.NullFormatter())
            
            if feats == True:
                axarr[r,c].set_ylim([-1.3, 1.5])
                if feats2 != 'win':
                    axarr[r,c].plot(feat[(i)], 'r', linewidth=0.5, label='WBFE Waveforms $W_n$ for two iterations')
                
            
            axarr[r,c].legend(loc = 9, fontsize = 'small', borderaxespad=0., frameon=False)
            # majorLocator = MultipleLocator(0.2)
            # majorFormatter = FormatStrFormatter('%.1f')
            # axarr[nrows-1, 0].yaxis.set_major_locator(majorLocator)
            # axarr[nrows-1, 0].yaxis.set_major_formatter(majorFormatter)
            # axarr[r,c].grid()
            # if r!=nrows-1:
                # axarr[r,c].yaxis.set_major_formatter(plt.NullFormatter())
                # axarr[r,c].xaxis.set_major_formatter(plt.NullFormatter())
            # if c!=0:
            #     axarr[r,c].yaxis.set_major_formatter(plt.NullFormatter())
            #     axarr[r,c].xaxis.set_major_formatter(plt.NullFormatter())

        axarr[-1,0].set_ylabel('Normalized Amplitude')
        if feats == True:
            plt.xlim([0, len(stream[i].data)])
            axarr[-1,0].set_xlabel('Lag Time [s]')
            # axarr[-1,1].set_xlabel('Lag Time [s]')

        elif feats == 'corrs': 
            axarr[-1,0].set_xlabel('Lag time [s]')
            plt.xlim([np.min(f.time), np.max(f.time)])

        elif feats ==False:
            axarr[-1,0].set_xlabel('Time after $t_s$ [d]')
            axarr[-1,1].set_xlabel('Time after $t_s$ [d]')
            plt.xlim([0, 10])
            # if proc == True:
                # plt.suptitle('Preprocessed continuous noise data')
            # else: 
                # plt.suptitle('Raw continuous noise data')
    
    return fig

test_big = False
if test_big ==True: 
    # from basic_functions import *
    numfeat=2
    f = featureextracter_load('all', project ='/a11c/', number_of_features=numfeat, period1 =1, pertrue=False)
    fig = bigplotter(f)
    fig.savefig(fpath+'corrs_postproc_feeeat.pdf')
    plt.close(fig)

    f = featureextracter_load('all', project ='/glob2/', number_of_features=numfeat, period1 =1, pertrue=False)
    fig = bigplotter(f)
    fig.savefig(fpath+'corrs_postproc_feeeat_glob.pdf')
    plt.close(fig)

    f = featureextracter_load('all', project ='/a11c/', number_of_features=numfeat, period1 =1, pertrue=False)
    f.get_time()
    fig = bigplotter(f, feats2='win')
    fig.savefig(fpath+'corrs_postproc_nofeat.pdf')
    plt.close(fig)

    f = featureextracter_load('all', project ='/glob2/', number_of_features=numfeat, period1 =1, pertrue=False)
    f.get_time()
    fig = bigplotter(f, feats2='win')
    fig.savefig(fpath+'corrs_postproc_nofeat_glob.pdf')
    plt.close(fig)
    # plt.show()

periods = ["50-100s", "10_50s", "100_200s", "1_25s", "25_50s", "20_40s", "5_15s"]
two =False
if two ==True: 
    # from basic_functions import *
    # f = featureextracter_load(type='all', project='/a11c/', number_of_features=2, period1 = 1)
    numfeat=2
    f = featureextracter_load('all', project ='/glob/', number_of_features=numfeat, period1 =1, pertrue=False)
    resample(f, step=30)

    f.recons3 = f.reconstructions
    # f1, ax1 = f.plot_stream()
    i = 0
    for trace in f.stream3: 
        trace.data = f.recons3[i]
        i+=1
    # f2, ax2 = f.plot_stream(which=f.stream3)
    

    f3, ax3 = f.plot_stream2(subf = True, streamarr = [f.stream_, f.stream3], 
                             headers=['Correlations', 'FE, N='], features=['', numfeat], frequencies=[periods[0], periods[0]])
    # fig2, ax = f.plot_stream2(subf = True, streamarr = [f.stream_], 
                             # headers=['Correlations', 'FE, N='], features=['', 4], frequencies=['50-100s', '50-100s'])
    f3.savefig(fpath+'sections_glob.pdf')
    plt.close(f3)

three = False
if three==True:
    numfeat=2
    f = featureextracter_load('all', project ='/a11c/', number_of_features=numfeat, period1 =1, pertrue=False)
    # resample(f, step=10)
    # RECONSTRUCIONS
    f.stream_ = f.stream_[3:10]
    f.reconstructions = f.reconstructions[3:10]
    f.ftfeatures = f.ftfeatures[3:10]
    fig9 = f.plot_reconstructions()
    # fig9.savefig(fpath+'reconstructions_a110001.pdf')
    # plt.close(fig9)

five = False
if five == True:

    raw = '/media/patrick/Data1/exch/DAINT/download/correlations/a11/a11c/*.SAC'
    f = featureextracter(raw)
    # f.stream_ = f.stream_[4:]
    f.get_time()
    fig = bigplotter(f, feats='corrs')
    fig.savefig(fpath+'corrs_raw_a.pdf')
    plt.close(fig)
    del f, fig

    raw = '/media/patrick/Data1/exch/DAINT/download/correlations/glob/globc/*.SAC'
    f = featureextracter(raw)
    f.get_time()
    fig = bigplotter(f, feats='corrs')
    fig.savefig(fpath+'corrs_raw_g.pdf')
    plt.close(fig)
    del f, fig
    # plt.show()
    # pass
six = True
if six == True: 
    raw = '/media/patrick/Data1/exch/DAINT/download/processed/a11c/*.MSEED'
    # raw = '/media/patrick/Data1/exch/Downloads/a10'
    f = featureextracter(raw)
    f.get_time()
    fig1 = bigplotter(f, feats=False, proc = True)
    fig1.savefig(fpath+'raws_preproc.png')
    plt.close(fig1)
    del f, fig1

if six == True: 
    raw = '/media/patrick/Data1/exch/Downloads/a10/a10c/*.mseed'
    # raw = '/media/patrick/Data1/exch/Downloads/a10'
    f = featureextracter(raw)
    f.get_time()
    fig2 = bigplotter(f, feats=False)
    fig2.savefig(fpath+'raws_raw.png')
    plt.close(fig2)
    del f, fig2
plt.show()
