from mpl_toolkits.basemap import Basemap
import numpy as np 
import glob
import os, sys, glob
from obspy import read_inventory
import matplotlib.pyplot as plt
sys.path.append(os.path.abspath('..'))

from pathmaker import basepath_f


def create_stations(save = False):
    print 'creating the file....'
    project1 = 'a10'
    project2 = 'a11b'
    xmlpath = '/media/patrick/Data1/PAITZ_THESIS/DATA/RAWS/Downloads/a10/a10stationxml/'

    correlationpath = '/home/patrick/1Thesis/nFINAL/RESULTS/DP/traces_for_inversion/*.mseed'
    gxml = os.path.basename(glob.glob(xmlpath+'*.xml')[0]).split('.xml')[0]

    corrlist = glob.glob(correlationpath)
    srcslon = np.array([])
    srcslat = np.array([])
    reclon =  np.array([])
    reclat =  np.array([])
    for ii in range(len(corrlist)):
        if ii%10 == 0:
            print ('%.2f ') % (float(ii)/len(corrlist)*100) + '%'
        gcor = os.path.basename(corrlist[ii]).split('.'+'1'+'.SAC')[0]
        s_net, s_sta, r_net, r_sta = extract_infos(gcor)
        xml = find_xml(xmlpath, s_net, s_sta)[0]
        lat1, lon1 = find_coord(xml)
        srcslon = np.append(srcslon,lon1)
        srcslat = np.append(srcslat,lat1)
        xml = find_xml(xmlpath, r_net, r_sta)[0]
        lat2, lon2 = find_coord(xml)
        reclon = np.append(reclon,lon2)
        reclat = np.append(reclat,lat2)
    print reclon
    create_points(srcslat, srcslon)
    create_points(reclat, reclon,fname='reca10')
        
def extract_infos(gcor):
    source = gcor.split('-')[0]
    receiver = gcor.split('-')[-1] 
    s_net = source.split('.')[0]
    s_rec = source.split('.')[1]
    r_net = receiver.split('.')[0]
    r_rec = receiver.split('.')[1]
    return s_net, s_rec, r_net, r_rec

def find_xml(xmlpath, net, sta):
    xml =  glob.glob(xmlpath+net+'.'+sta+'.xml')
    return xml

def find_coord(path_to_xml):
    sta = path_to_xml.split('/')[-1].split('.')[1]
        # try:
    inv = read_inventory(path_to_xml)
    sta = inv[0][0]
    staname = sta.code
    lat=sta.latitude
    lon=sta.longitude
    return float(lat), float(lon)

def create_points(lat1, lon1, fname='srca10'): 
    path = '/home/patrick/Desktop/'
    f1   = path+fname+'.txt'
    t = open(f1,'w')
    for i in range(len(lat1)): 
        t.write(str(lat1[i]) +',' +str(lon1[i]) +'\n')
    t.close()
    
    

if __name__ == '__main__': 
    create_stations()
    # print os.path.dirname(os.path.realpath(__file__))


# lat = df.loc[:, "Latitude"].as_matrix()
# lon = df.loc[:, "Longitude"].as_matrix()
