import os, inspect
from pathlib import Path
from mydetails import info

def pathmaker(type, project):
    """
    Makes the paths, define basepath (where the Module is sitting)
    pertrue is needed for other period ranks than the default period is 50-100 s
    type is either *.SAC or *.MSEED/*.mseed
    project is the project folder
    """
    basepath = basepath_f()
    _,_,_,_, traces = info()
    # traces     = basepath+'/FILES/traces/'+project+'*.SAC'
    features   = basepath+'/FILES/features/'+project
    subsets    = basepath+'/FILES/subsets/'+project
    classi     = basepath+'/CLASSTOOL/classified/'+project

    return traces, features, subsets, classi

def basepath_f(): 
    """
    Basepath for the functions
    """
    path = os.path.dirname(os.path.abspath(inspect.stack()[0][1]))
    basepath = Path(path).parents[2]
    # path_classifications_hand + '/' + project + '/' + project + '_visualclassification' + '_' + str(name1)
    return str(basepath)

def classificationfile():
    _,_,_, classi = pathmaker(type,project)

def pathmaker_plot():
    """
    Makes the paths, define basepath (where the Module is sitting)
    pertrue is needed for other period ranks than the default period is 50-100 s
    type is either *.SAC or *.MSEED/*.mseed
    project is the project folder
    """
    basepath = basepath_f()
    _,_,_,_, traces = info()
    # traces     = basepath+'/FILES/traces/'+project+'*.SAC'
    plots   = basepath+'/FILES/plots/'

    return plots

