import os, inspect, shutil


def mkdir(directory, mode=1):
    """
    Helper function to create/remove directories based on the mode ([0 or 1 or 'mk']: create ['rm' or 2]: delete
    :param directory: path to directory
    :param mode:      mode
    :return:          Nothing
    """
    if mode in [0, 1, 'mk']:
        if not os.path.exists(directory):
            print('created', directory)
            os.makedirs(directory)
    if mode in ['rm', 2]:
        if os.path.exists(directory):
            print('deleted', directory)
            shutil.rmtree(directory)


def jupyter_run():
    """
    Runs the initialization. Can create paths (init mode 1) or delete paths (init mode 2). In case of init mode 2 please
    keep in mind that the full paths to all the folders will be deleted - so back up your data in case you may need it!
    """

    mode = int(input('Choose your init mode: 1: create project, 2: delete project\n>> '))

    print('Preparing your project....')
    name = input("Enter your Project Name to set up the folder structure for you\n>> ")
    if mode == 2:
        tmpstr = ('Do you really want to remove project' + name + '\t [y/n]\n>> ')
        print('Deleting Projects is disabled. Please see sourcecode lines 33 to 38 ')
        # mode = 0
        # Uncomment the following lines if you really want to
        tmp = input(tmpstr)
        if tmp == 'y':
            mode = 2
        else:
            mode = 0

    path0 = os.path.dirname(os.path.abspath(inspect.stack()[0][1]))
    pathcl = os.path.join(path0, 'CLASSTOOL/classified/')

    mkdir(os.path.join(pathcl, name), mode=mode)

    pathfi = os.path.join(path0, 'FILES/')
    pathfif = os.path.join(pathfi, 'features/')

    mkdir(os.path.join(pathfif, name), mode=mode)

    pathfin = os.path.join(pathfi, 'networks/')
    n_networks = '10'

    for i in range(int(n_networks)):
        if mode == 1:
            mkdir(os.path.join(pathfin, str(i), name, name))
        elif mode == 2:
            mkdir(os.path.join(pathfin, str(i), name), mode=mode)

    pathfis = os.path.join(pathfi, 'subsets/')
    n_subsets = '10'

    for i in range(int(n_subsets)):
        if mode == 1:
            mkdir(os.path.join(pathfis, name, str(i), 'Test/'))
            mkdir(os.path.join(pathfis, name, str(i), 'Training/'))
        elif mode == 2:
            mkdir(os.path.join(pathfis, name), mode=mode)

    pathfit = os.path.join(pathfi, 'traces/')
    mkdir(os.path.join(pathfit, name), mode=mode)
    mkdir(os.path.join(path0, 'FILES/', 'plots/', name), mode=mode)
    pathplot = os.path.join(path0, 'FILES/', 'plots/', name)
    mkdir(os.path.join(pathplot, 'ft'), mode=mode)
    mkdir(os.path.join(pathfi, 'convergence', name), mode=mode)
    mkdir(os.path.join(pathfi, 'waveforms', name), mode=mode)
    mkdir(os.path.join(path0, 'RESULTS', name), mode=mode)
    mkdir(os.path.join(path0, 'RESULTS', 'waveforms', name), mode=mode)
    mkdir(os.path.join(path0, 'RESULTS', 'convergence', name), mode=mode)


if __name__ == '__main__':
    jupyter_run()
